Package io.vertx.ext.auth.oauth2.providers

## Interface SalesforceAuth

- All Superinterfaces:
    `OpenIDConnectAuth`

      public interface SalesforceAuth
      extends OpenIDConnectAuth

  Simplified factory to create an `OAuth2Auth` for Salesforce.
  Author:
    Paulo Lopes

- - ### Method Summary

    Static Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static OAuth2Auth` | `create​(Vertx vertx, String clientId, String clientSecret)` | Create a OAuth2Auth provider for Salesforce
    `static OAuth2Auth` | `create​(Vertx vertx, String clientId, String clientSecret, HttpClientOptions httpClientOptions)` | Create a OAuth2Auth provider for Salesforce
    `static Future<OAuth2Auth>` | `discover​(Vertx vertx, OAuth2Options config)` | Create a OAuth2Auth provider for OpenID Connect Discovery.

- - ### Method Detail

    - #### create

          static OAuth2Auth create​(Vertx vertx,
                                   String clientId,
                                   String clientSecret)

      Create a OAuth2Auth provider for Salesforce
      Parameters:
        `clientId` - the client id given to you by Salesforce
        `clientSecret` - the client secret given to you by Salesforce

    - #### create

          static OAuth2Auth create​(Vertx vertx,
                                   String clientId,
                                   String clientSecret,
                                   HttpClientOptions httpClientOptions)

      Create a OAuth2Auth provider for Salesforce
      Parameters:
        `clientId` - the client id given to you by Salesforce
        `clientSecret` - the client secret given to you by Salesforce
        `httpClientOptions` - custom http client options

    - #### discover

          static Future<OAuth2Auth> discover​(Vertx vertx,
                                             OAuth2Options config)

      Create a OAuth2Auth provider for OpenID Connect Discovery. The discovery will use the default site in the configuration options and attempt to load the well known descriptor. If a site is provided (for example when running on a custom instance) that site will be used to do the lookup.

      If the discovered config includes a json web key url, it will be also fetched and the JWKs will be loaded into the OAuth provider so tokens can be decoded.

      Parameters:
        `vertx` - the vertx instance
        `config` - the initial config
      Returns:
        future with the instantiated Oauth2 provider instance handler
      See Also:
        `SalesforceAuth#discover(Vertx, OAuth2Options, Handler)`